﻿using PLplot;
using System;
using System.Collections.Generic;

public static class Utils
{
    public static IEnumerable<T> RangeInclusive<T>(T start, T stop, T step)
    {
        dynamic dStart = start;
        dynamic dStop = stop;
        dynamic dStep = step;

        if (dStep == 0)
            throw new ArgumentException("Parameter step cannot equal zero.");

        if (dStart < dStop && dStep > 0)
        {
            for (var i = dStart; i <= dStop; i += dStep)
            {
                yield return i;
            }
        }
        else if (dStart > dStop && dStep < 0)
        {
            for (var i = dStart; i >= dStop; i += dStep)
            {
                yield return i;
            }
        }
    }

    public static void Point(this PLStream pl, double x, double y, char code)
    {
        pl.poin(new double[] { x }, new double[] { y }, code);
    }

    public static bool GetCloseToZeroSlope(this double value)
    {
        return Math.Abs(value) < 1e-03 ? true : false;
    }
}
